/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.34).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package com.owc.singularity.server.api;


import java.util.List;

import org.springdoc.core.annotations.ParameterObject;
import org.springframework.core.io.AbstractResource;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;

import com.owc.singularity.server.model.QueryOptions;
import com.owc.singularity.server.model.module.ModuleInfo;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.media.ArraySchema;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;
import jakarta.servlet.http.HttpServletRequest;


@Validated
public interface ModulesApi {

    @Operation(summary = "Get all Modules", description = "Get the information of all modules", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "read:module" }) }, tags = { "module" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "Modules array", content = @Content(mediaType = "application/json", array = @ArraySchema(schema = @Schema(implementation = ModuleInfo.class)))) })
    @GetMapping(value = "/modules", produces = { "application/json; charset=utf-8" })
    ResponseEntity<List<ModuleInfo>> getAllModules(@ParameterObject QueryOptions options);

    @Operation(summary = "Get a Module by id", description = "Get a single Module by id", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "read:module" }) }, tags = { "module" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "Module object", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Module.class))),

            @ApiResponse(responseCode = "404", description = "Not found") })
    @GetMapping(value = "/modules/{moduleId}", produces = { "application/json; charset=utf-8" })
    ResponseEntity<ModuleInfo> getModuleById(
            @Parameter(in = ParameterIn.PATH, description = "ID of module to return", required = true, schema = @Schema()) @PathVariable("moduleId") String moduleId);

    @Operation(summary = "Download a Module jar by id", description = "Download a single Module jar by id", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "read:module" }) }, tags = { "module" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "Module jar file", content = @Content(mediaType = "application/octet-stream", schema = @Schema(type = "string", format = "binary"))),

            @ApiResponse(responseCode = "404", description = "Not found") })
    @GetMapping(value = "/modules/{moduleId}/download", produces = { "application/octet-stream", "application/java-archive" })
    ResponseEntity<AbstractResource> downloadModuleById(
            @Parameter(in = ParameterIn.PATH, description = "ID of module to return", required = true, schema = @Schema()) @PathVariable("moduleId") String moduleId);

    @Operation(summary = "Upload a module jar for job execution", description = "Upload a module jar for job execution", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "upload:module" }) }, tags = { "module" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "201", description = "", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ModuleInfo.class))) })
    @PostMapping(value = "/modules", produces = { "application/json; charset=utf-8" }, consumes = { "application/java-archive", "application/octet-stream" })
    ResponseEntity<ModuleInfo> uploadModule(
            @Parameter(in = ParameterIn.DEFAULT, description = "The jar file", schema = @Schema(type = "string", format = "binary")) HttpServletRequest request);

    @Operation(summary = "Delete a module", description = "Delete a module", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "delete:module" }) }, tags = { "module" })
    @ApiResponses(value = { @ApiResponse(responseCode = "204", description = "Deleted") })
    @DeleteMapping(value = "/modules/{moduleId}")
    ResponseEntity<ModuleInfo> deleteModuleById(
            @Parameter(in = ParameterIn.PATH, description = "ID of module to delete", required = true, schema = @Schema()) @PathVariable("moduleId") String moduleId);
}
